@inproceedings{artho-ase2015-tool,
  author = {C. Artho and M. Seidl and Q. Gros and E. Choi and T. Kitamura and A. Mori and R. Ramler and Y. Yamagata},
  title     = {Model-based Testing of Stateful {APIs} with {Modbat}},
  booktitle = {Proc.\ 30th Int.\  Conf.\ on Automated Software Engineering (ASE~2015)},
  year      = {2015},
  address   = {Lincoln, USA},
  publisher = {IEEE},
  pages = {858--863},
}

@misc{java-api,
author="Oracle",
title="Overview ({Java} Platform {SE} 8)",
note = "\url{http://docs.oracle.com/javase/8/docs/api/overview-summary.html}",
year = 2015,
}

@inproceedings{artho-ftscs2013,
  author = {C. Artho and K. Hayamizu and R. Ramler and Y. Yamagata},
  title = {With an Open Mind: How to Write Good Models},
  booktitle = {Proc.\ 2nd Int.\ Workshop on Formal Techniques for Safety-Critical Systems (FTSCS~2013)},
  address = {Queenstown, New Zealand},
  pages = {3--18},
  series = {CCIS},
  number = {419},
  publisher = {Springer},
  year = {2014},
}

@misc{scala-require-2010,
  author = {J. Eichar},
  title = {Daily {Scala}: Assert, Require, Assume},
  year = 2010,
  note = {\url{http://daily-scala.blogspot.jp/2010/03/assert-require-assume.html}},
}

@misc{scala,
  author = {A. Moors and S. Tisue and J. Zaugg and Ichoran and L. Rytz and V. Ureche and D. Shabalin and E. Burmako and H. Miller and D. Wall and I. Dragos and A. Prokopec and J. Bogucki},
  title = {The {Scala} Programming Language},
  year = 2015,
  note = {\url{http://www.scala-lang.org/}},
}

@inproceedings{mockus2009test,
  title={Test coverage and post-verification defects: A multiple case study},
  author={Mockus, Audris and Nagappan, Nachiappan and Dinh-Trong, Trung T},
  booktitle={Empirical Software Engineering and Measurement, 2009. ESEM 2009. 3rd International Symposium on},
  pages={291--301},
  year={2009},
  organization={IEEE}
}

@inproceedings{conf/rv/Odersky10,
  author = {Odersky, Martin},
  booktitle="Proc.\ 1st Int.\ Conf.\ on Run-time Verification (RV~2010)",
  editor = {Barringer, Howard and Falcone, Yli\`{e}s and Finkbeiner, Bernd and Havelund, Klaus and Lee, Insup and Pace, Gordon J. and Rosu, Grigore and Sokolsky, Oleg and Tillmann, Nikolai},
  pages = {51--57},
  publisher = {Springer},
  series = {LNCS},
  title = {Contracts for {Scala}},
  volume = 6418,
  year = 2010,
}

@book{GoslingJoySteeleBrachaBuckley,
  author={J. Gosling and B. Joy and G. Steele and G. Bracha and A. Buckley},
  title={The {Java Language} Specification, {Java} {SE} 8 Edition},
  publisher={Oracle},
  year={2015},
}

@article{meyer1992applying,
  title={Applying 'design by contract'},
  author={Meyer, Bertrand},
  journal={Computer},
  volume={25},
  number={10},
  pages={40--51},
  year={1992},
  publisher={IEEE}
}

@article{Bertolino:2011:MMR:1988089.1988473,
 author = {Bertolino, A. and De Angelis, G. and Di Sandro, A. and Sabetta, A.},
 title = {Is my model right? Let me ask the expert},
 journal = {J. Syst. Softw.},
 issue_date = {July, 2011},
 volume = {84},
 number = {7},
 month = jul,
 year = {2011},
 issn = {0164-1212},
 pages = {1089--1099},
 numpages = {11},
 url = {http://dx.doi.org/10.1016/j.jss.2011.01.054},
 doi = {10.1016/j.jss.2011.01.054},
 acmid = {1988473},
 publisher = {Elsevier Science Inc.},
 address = {New York, NY, USA},
 keywords = {Domain modeling, Experience report, Model driven engineering, Model validation},
}

@inproceedings{Calikli:2010:EAF:1868328.1868344,
 author = {Calikli, G. and Bener, A.},
 title = {Empirical analyses of the factors affecting confirmation bias and the effects of confirmation bias on software developer/tester performance},
 booktitle = {Proc.\ 6th Int.\ Conf.\ on Predictive Models in Software Engineering},
 series = {PROMISE~2010},
 year = {2010},
 isbn = {978-1-4503-0404-7},
 location = {Timi\&scedil;oara, Romania},
 pages = {10:1--10:11},
 articleno = {10},
 numpages = {11},
 url = {http://doi.acm.org/10.1145/1868328.1868344},
 doi = {10.1145/1868328.1868344},
 acmid = {1868344},
 publisher = {ACM},
 address = {New York, NY, USA},
 keywords = {cognitive biases, confirmation bias, software engineering, software testing},
}

@article{Utting:2012:TMT:2344867.2344870,
 author = {Utting, M. and Pretschner, A. and Legeard, B.},
 title = {A taxonomy of model-based testing approaches},
 journal = {Softw. Test. Verif. Reliab.},
 issue_date = {August 2012},
 volume = {22},
 number = {5},
 month = aug,
 year = {2012},
 issn = {0960-0833},
 pages = {297--312},
 numpages = {16},
 url = {http://dx.doi.org/10.1002/stvr.456},
 doi = {10.1002/stvr.456},
 acmid = {2344870},
 publisher = {John Wiley and Sons Ltd.},
 address = {Chichester, UK},
 keywords = {model-based testing approaches, survey, taxonomy},
}

@inproceedings{Pacheco:2007:FRT:1248820.1248841,
 author = {Pacheco, C. and Lahiri, S. and Ernst, M. and Ball, T.},
 title = {Feedback-Directed Random Test Generation},
 booktitle = {Proc.\ 29th Int.\ Conf.\ on Softw.\ Eng.},
 series = {ICSE~2007},
 year = {2007},
 isbn = {0-7695-2828-7},
 pages = {75--84},
 numpages = {10},
 url = {http://dx.doi.org/10.1109/ICSE.2007.37},
 doi = {10.1109/ICSE.2007.37},
 acmid = {1248841},
 publisher = {IEEE Computer Society},
 address = {Washington, DC, USA},
} 

@inproceedings{Ramler2013,
 author = {Ramler, R. and Wolfmaier, K. and Kopetzky, T.},
 title = {A Replicated Study on Random Test Case Generation and Manual Unit Testing: How Many Bugs Do Professional Developers Find?},
 booktitle = {Proc.\ 37th Annual Int.\ Comp.\ Software \& Applications Conf.},
 series = {COMPSAC 2013},
 year = {2013},
 pages = {484--491},
 numpages = {8},
 publisher = {IEEE Computer Society},
 address = {Washington, DC, USA},
} 

@book{Ammann:2008:IST:1355340,
 author = {Ammann, P. and Offutt, J.},
 title = {Introduction to Software Testing},
 year = {2008},
 isbn = {0521880386, 9780521880381},
 edition = {1},
 publisher = {Cambridge University Press},
 address = {New York, USA},
} 

@inproceedings{taguchi2013mcbok,
  author = {K. Taguchi and H. Nishihara and T. Aoki and F. Kumeno and K. Hayamizu and K. Shinozaki},
  title = {Building a Body of Knowledge on Model Checking for Software Development},
  booktitle = {Proc.\ 37th Annual International Computer Software \& Applications Conf.\ (COMPSAC~2013)},
  year = {2013},
  address = {Kyoto, Japan},
  publisher = {IEEE},
}

@article{Kramer:2007:AKC:1232743.1232745,
 author = {Kramer, J.},
 title = {Is abstraction the key to computing?},
 journal = {Commun. ACM},
 issue_date = {April 2007},
 volume = {50},
 number = {4},
 month = apr,
 year = {2007},
 issn = {0001-0782},
 pages = {36--42},
 numpages = {7},
 url = {http://doi.acm.org/10.1145/1232743.1232745},
 doi = {10.1145/1232743.1232745},
 acmid = {1232745},
 publisher = {ACM},
 address = {New York, NY, USA},
} 

@article{jia2011analysis,
  title={An analysis and survey of the development of mutation testing},
  author={J., Yue and H., Mark},
  journal={Software Engineering, IEEE Transactions on},
  volume={37},
  number={5},
  pages={649--678},
  year={2011},
  publisher={IEEE}
}

@incollection{Black:2001:MMC:571305.571311,
 author = {Black, P. and Okun, V. and Yesha, Y.},
 chapter = {Mutation of model checker specifications for test generation and evaluation},
 booktitle = {Mutation testing for the new century},
 editor = {Wong, E.},
 year = {2001},
 isbn = {0-7923-7323-5},
 pages = {14--20},
 numpages = {7},
 url = {http://dl.acm.org/citation.cfm?id=571305.571311},
 acmid = {571311},
 publisher = {Kluwer Academic Publishers},
 address = {Norwell, MA, USA},
 keywords = {model checking, mutation operators, specification mutation, test generations},
} 

@inproceedings{DBLP:conf/ijcai/PillQ13,
  author    = {I. Pill and
               T. Quaritsch},
  title     = {Behavioral Diagnosis of {LTL} Specifications at Operator Level},
  booktitle = {Proc.\ 23rd Int.\ Joint Conf.\ on Artificial Intelligence (IJCAI~2013)},
  year      = {2013},
  ee        = {http://www.aaai.org/ocs/index.php/IJCAI/IJCAI13/paper/view/6595},
  bibsource = {DBLP, http://dblp.uni-trier.de},
  address = {Beijing, China},
  publisher = {IJCAI/AAAI}
}

@article{DBLP:journals/ac/MemonN10,
  author    = {A. Memon and
               B. Nguyen},
  title     = {Advances in Automated Model-Based System Testing of Software
               Applications with a {GUI} Front-End},
  journal   = {Advances in Computers},
  volume    = {80},
  year      = {2010},
  pages     = {121--162},
  ee        = {http://dx.doi.org/10.1016/S0065-2458(10)80003-8},
  bibsource = {DBLP, http://dblp.uni-trier.de}
}

@article{DBLP:journals/jmlr/SteffenHI12,
  author    = {B. Steffen and
               F. Howar and
               M. Isberner},
  title     = {Active Automata Learning: From {DFAs} to Interface Programs
               and Beyond},
  journal   = {Journal of Machine Learning Research---Proceedings Track},
  volume    = {21},
  year      = {2012},
  pages     = {195--209},
  ee        = {http://jmlr.csail.mit.edu/proceedings/papers/v21/steffen12a.html},
  bibsource = {DBLP, http://dblp.uni-trier.de}
}

@inproceedings{artho-hvc2013,
  author = {C. Artho and A. Biere and M. Hagiya and E. Platon and M. Seidl and Y. Tanabe and M. Yamamoto},
  title = {Modbat: A Model-based {API} Tester for Event-driven Systems},
  booktitle = {Proc.\ 9th Haifa Verification Conference (HVC~2013)},
  year = {2013},
  series = {LNCS},
  publisher={Springer},
  volume = {8244},
  pages = {112--128},
  address = {Haifa, Israel},
}

@article{bowman2006stop,
  title={How to stop time stopping},
  author={Bowman, H.},
  journal={Form. Asp. Comput.},
  volume={18},
  number={4},
  pages={459--493},
  year={2006}
}

@INPROCEEDINGS{Bowman98automaticverification,
    author = {H. Bowman and G. Faconti and J-P. Katoen and D. Latella and M. Massink},
    title = {Automatic verification of a lip synchronisation algorithm using {UPPAAL}},
    booktitle = {Proc.\ 3rd Int.\ Workshop on Formal Methods for Industrial Critical Systems},
    year = {1998},
    pages = {97--124},
    publisher = {CWI}
}

@article{DBLP:journals/scp/Schuppan12,
  author    = {V. Schuppan},
  title     = {Towards a notion of unsatisfiable and unrealizable cores
               for {LTL}},
  journal   = {Sci. Comput. Program.},
  volume    = {77},
  number    = {7-8},
  year      = {2012},
  pages     = {908-939},
  ee        = {http://dx.doi.org/10.1016/j.scico.2010.11.004},
  bibsource = {DBLP, http://dblp.uni-trier.de}
}

@article{Yu:2006:CMM:1183058.1183060,
 author = {Yu, Y. and Lau, M.},
 title = {A comparison of {MC/DC}, {MUMCUT} and several other coverage criteria for logical decisions},
 journal = {J. Syst. Softw.},
 issue_date = {May 2006},
 volume = {79},
 number = {5},
 month = may,
 year = {2006},
 issn = {0164-1212},
 pages = {577--590},
 numpages = {14},
 url = {http://dx.doi.org/10.1016/j.jss.2005.05.030},
 doi = {10.1016/j.jss.2005.05.030},
 acmid = {1183060},
 publisher = {Elsevier Science Inc.},
 address = {New York, NY, USA},
 keywords = {Condition coverage, Coverage criteria, Decision coverage, Logical decisions, MC/DC, MUMCUT},
} 

@inproceedings{DBLP:conf/dac/BeattyB94,
  author    = {D. Beatty and
               R. Bryant},
  title     = {Formally Verifying a Microprocessor Using a Simulation Methodology},
  booktitle = {Proc.\ 31st Conf.\ on Design Automation (DAC~1994)},
  address = {San Diego, USA},
  year      = {1994},
  pages     = {596--602},
  ee        = {http://doi.acm.org/10.1145/196244.196575},
  bibsource = {DBLP, http://dblp.uni-trier.de}
}

@inproceedings{conf/dac/BeerBEL96,
  added-at = {2002-12-16T00:00:00.000+0100},
  author = {Beer, I. and Ben-David, S. and Eisner, C. and Landver, A.},
  biburl = {http://www.bibsonomy.org/bibtex/2a5ffc7c59d52f986cd8892942a0396aa/dblp},
  date = {2002-12-16},
  description = {dblp},
  ee = {http://doi.acm.org/10.1145/240518.240642},
  interhash = {f25914a10ddbc6ee74632767d752386a},
  intrahash = {a5ffc7c59d52f986cd8892942a0396aa},
  keywords = {dblp},
  pages = {655-660},
  timestamp = {2002-12-16T00:00:00.000+0100},
  title = {RuleBase: An Industry-Oriented Formal Verification Tool},
  booktitle = {Proc.\ 33rd Conf.\ on Design Automation (DAC~1996)},
  url = {http://dblp.uni-trier.de/db/conf/dac/dac96.html#BeerBEL96},
  address = {Las Vegas, USA},
  year = 1996
}

@inproceedings{artho-dsw12,
  author = {C. Artho and A. Biere and M. Hagiya and R. Potter and R. Ramler and Y. Tanabe and F. Weitl and M. Yamamoto},
  title = {Modbat: A model-based {API} tester for event-driven systems},
  booktitle = {Proc.\ Dependable Systems Workshop (DSW~2012)},
  year = {2012},
  address = {Kobe, Japan},
  note = {Tool demonstration (short paper)},
}

@inproceedings{artho-ase2013,
  author    = {C. Artho and M. Hagiya and R. Potter and Y. Tanabe and
               F. Weitl and M. Yamamoto},
  title     = {Software Model Checking for Distributed Systems with Selector-Based, Non-Blocking Communication},
  booktitle = {Proc.\ 28th Int.\  Conf.\ on Automated Software Engineering (ASE~2013)},
  year      = {2013},
  address   = {Palo Alto, USA},
}

@article{zeller02simplifying,
    author = "A. Zeller and R. Hildebrandt",
    title = "Simplifying and Isolating Failure-Inducing Input",
    journal = "Software Engineering",
    volume = "28",
    number = "2",
    pages = "183--200",
    year = "2002",
}

@inproceedings{ArthoBiereSeidl-TAP13,
author={C. Artho and A. Biere and M. Seidl},
title={Model-Based Testing for Verification Backends},
booktitle={Proc.\ 7th Int.\ Conf.\ on Tests \& Proofs (TAP 2013)},
series={LNCS},
pages={39--55},
publisher={Springer},
year={2013},
}

@article{lj-nginx,
  author = "W. Reese",
  title = "Nginx: the High-Performance Web Server and Reverse Proxy",
  journal = "Linux Journal",
  volume = "173",
  year = "2008",
}

@inproceedings{artho-tools2008,
  author={C. Artho and W. Leungwattanakit and M. Hagiya and Y. Tanabe},
  title ={Efficient Model Checking of Networked Applications},
  booktitle={Proc.\ TOOLS~EUROPE~2008},
  year={2008},
  pages={22--40},
  publisher={Springer},
  series={LNBIP},
  volume={19},
  address={Zurich, Switzerland},
}

@inproceedings{Veanes07model-basedtesting,
    author = {M. Veanes and C. Campbell and W. Grieskamp and W. Schulte and N. Tillmann and L. Nachmanson},
    title = {Model-Based Testing of Object-Oriented Reactive Systems with {Spec Explorer}},
    booktitle = {Formal Methods and Testing 2008},
    year = {2008},
    series = {LNCS},
    volume = {4949},
    publisher = {Springer},
    pages = {39--76},
}

@book{Jacky:2007:MST:1349741,
 author = {Jacky, J. and Veanes, M. and Campbell, C. and Schulte, W.},
 title = {Model-Based Software Testing and Analysis with C\#},
 edition = {1},
 year = {2007},
} 

@article{TSE12_EvoSuite,
author = {G. Fraser and A. Arcuri},
title = {Whole Test Suite Generation},
journal ={IEEE Transactions on Software Engineering},
year={2013}, 
month={feb. }, 
volume={39}, 
number={2}, 
pages={276 -291}, 
}

@inproceedings{Kanstren2012,
  author    = {T. Kanstr{\'e}n and
               O. Puolitaival},
  title     = {Using Built-In Domain-Specific Modeling Support to Guide
               Model-Based Test Generation},
  booktitle = {Proc.\ 7th Workshop on Model-Based Testing (MBT~2012)},
  pages     = {58--72},
  series    = {EPTCS},
  volume    = {80},
  year      = {2012},
}

@article{Gansner00anopen,
    author = {E. Gansner and S. North},
    title = {An open graph visualization system and its applications to software engineering},
    journal = {Software---Practice and Experience},
    year = {2000},
    volume = {30},
    number = {11},
    pages = {1203--1233}
}

@article{Godefroid:2005:DDA:1064978.1065036,
 author = {Godefroid, P. and Klarlund, N. and Sen, K.},
 title = {DART: directed automated random testing},
 journal = {SIGPLAN Not.},
 issue_date = {June 2005},
 volume = {40},
 number = {6},
 month = jun,
 year = {2005},
 issn = {0362-1340},
 pages = {213--223},
 numpages = {11},
 url = {http://doi.acm.org/10.1145/1064978.1065036},
 doi = {10.1145/1064978.1065036},
 acmid = {1065036},
 publisher = {ACM},
 address = {New York, NY, USA},
 keywords = {automated test generation, interfaces, program verification, random testing, software testing},
} 

@article{Sen:2005:CCU:1095430.1081750,
 author = {Sen, K. and Marinov, D. and Agha, G.},
 title = {{CUTE}: a concolic unit testing engine for {C}},
 journal = {SIGSOFT Softw. Eng. Notes},
 issue_date = {September 2005},
 volume = {30},
 number = {5},
 month = sep,
 year = {2005},
 issn = {0163-5948},
 pages = {263--272},
 numpages = {10},
 url = {http://doi.acm.org/10.1145/1095430.1081750},
 doi = {10.1145/1095430.1081750},
 acmid = {1081750},
 publisher = {ACM},
 address = {New York, NY, USA},
 keywords = {concolic testing, data structure testing, explicit path model-checking, random testing, testing C programs, unit testing},
}

@inproceedings{Cheng:1993:AFT:157485.164585,
 author = {Cheng, K. and Krishnakumar, A.},
 title = {Automatic functional test generation using the extended finite state machine model},
 booktitle = {Proc.\ 30th Int.\ Design Automation Conference},
 series = {DAC 1993},
 year = {1993},
 isbn = {0-89791-577-1},
 location = {Dallas, Texas, USA},
 pages = {86--91},
 numpages = {6},
 url = {http://doi.acm.org/10.1145/157485.164585},
 doi = {10.1145/157485.164585},
 acmid = {164585},
 publisher = {ACM},
 address = {New York, NY, USA},
} 

@inproceedings{Kitamura2012,
  author    = {T. Kitamura and
               T. Do and
               H. Ohsaki and
               L. Fang and
               S. Yatabe},
  title     = {Test-Case Design by Feature Trees},
  booktitle = {Leveraging Applications of Formal Methods, Verification
               and Validation (ISoLA~2012).},
  year      = {2012},
  pages     = {458--473},
  publisher = {Springer},
  series    = {LNCS},
  volume    = {7609},
}

@article{Claessen:2000,
 author = {Claessen, K. and Hughes, J.},
 title = {{QuickCheck}: a lightweight tool for random testing of {Haskell} programs},
 journal = {SIGPLAN Not.},
 volume = {35},
 number = {9},
 year = {2000},
 pages = {268--279},
 publisher = {ACM},
 address = {New York, NY, USA},
} 

@book{wampler2009programming,
  author = {Wampler, D. and Payne, A.},
  publisher = {O'Reilly Media},
  series = {O'Reilly Series},
  title = {{Programming Scala}},
  year = 2009,
}

@book{Odersky2008,
 author = {Odersky, M. and Spoon, L. and Venners, B.},
 title = {Programming in {Scala}: A Comprehensive Step-by-step Guide},
 year = {2010},
 edition = {2nd},
 publisher = {Artima Inc.},
 address = {USA},
} 

@misc{conformiq,
  title={Conformiq {D}esigner},
  note = {\url{http://www.conformiq.com/products/conformiq-designer/}},
  year = 2013,
}

@misc{scalacheck,
  author={R. Nils},
  title={{ScalaCheck}, a powerful tool for automatic unit testing},
  note = {\url{https://github.com/rickynils/scalacheck}},
  year = 2013,
}

@article{artho-eurocast2009,
  author={C. Artho},
  title = {Separation of Transitions, Actions, and Exceptions in Model-based Testing},
  journal={Post-proceedings of 12th Int.\  Conf.\ on Computer Aided Systems Theory (Eurocast~2009)},
  year={2009},
  volume = {5717},
  number = {},
  pages = {279--286},
  publisher={Springer},
  series = {LNCS},
}

@inproceedings{ramler2012,
author = {R. Ramler and D. Winkler and M. Schmidt},
title = {Random Test Case Generation and Manual Unit Testing: Substitute or Complement in Retrofitting Tests for Legacy Code?},
booktitle ={36th Conf.\ on Software Engineering and Advanced Applications},
year = {2012},
pages = {286--293},
publisher = {IEEE Computer Society},
}
%address = {Los Alamitos, CA, USA},

@inproceedings{Poole01MDA,
  author = {J. Poole},
  title = {Model-Driven Architecture: Vision, Standards and Emerging Technologies},
  booktitle = {Workshop on Metamodeling and Adaptive Object Models},
  year = {2001},
  address = {Budapest, Hungary},
}

@inproceedings{javed07,
 author = {A. Javed and P. Strooper and G. Watson},
 title = {Automated Generation of Test Cases Using Model-Driven Architecture},
 booktitle = {Proc.\ 2nd Int.\ Workshop on Automation of Software Test (AST~2007)},
 year = {2007},
 pages = {3},
 publisher = {IEEE Computer Society},
 address = {Washington, USA},
}

@book{utting06,
 author = {M. Utting and B. Legeard},
 title = {Practical Model-Based Testing: A Tools Approach},
 year = {2006},
 publisher = {Morgan Kaufmann Publishers, Inc.},
 address = {San Francisco, USA},
}

@article{GroceVisser04,
  author    = {A. Groce and W. Visser},
  title     = {Heuristics for model checking Java programs},
  journal = "Int.\ Journal on Software Tools for Technology Transfer (STTT)",
  volume    = {6},
  number    = {4},
  year      = {2004},
  pages     = {260--276},
}

@inproceedings{artho-ast06,
  author = {C. Artho and A. Biere and S. Honiden and V. Schuppan and P. Eugster and M. Baur and B. Zweim\"{u}ller and P. Farkas},
  title = "Advanced Unit Testing -- How to Scale Up a Unit Test Framework",
  booktitle = "Proc.\ Workshop on Automation of Software Test (AST~2006)",
  year = "2006",
  address = "Shanghai, China",
}

@article{carreira98xception,
    author = "J. Carreira and H. Madeira and J. Gabriel Silva",
    title = "{Xception}: A Technique for the Experimental Evaluation of Dependability in Modern Computers",
    journal = "Software Engineering",
    volume = "24",
    number = "2",
    pages = "125--136",
    year = "1998",
}

@inproceedings{LiHR06,
  author    = {X. Li and H. Hoover and P. Rudnicki},
  title     = {Towards Automatic Exception Safety Verification},
  booktitle = {Proc.\ 14th Int.\ Symposium on Formal Methods (FM~2006)},
  year      = {2006},
  pages     = {396--411},
  publisher = {Springer},
  series    = {LNCS},
  volume    = {4085},
  address   = {Hamilton, Canada},
}

@inproceedings{artho06enforcer,
  author = "C. Artho and A. Biere and S. Honiden",
  title = "Enforcer -- Efficient Failure Injection",
  booktitle = "Proc.\ Int.\ Conference on Formal Methods (FM 2006)",
  year = "2006",
  address = "Canada",
}

@inproceedings{forresterempirical,
    author = "J. Forrester and B. Miller",
    title = "An Empirical Study of the Robustness of {W}indows {NT} Applications Using Random Testing",
    booktitle = "4th USENIX Windows System Symposium",
    year = "2000",
    address = "Seattle, USA",
    pages = "59--68",
}

@article{hsueh97fault,
    author = "M. Hsueh and T. Tsai and R. Iyer",
    title = "Fault Injection Techniques and Tools",
    journal = "IEEE Computer",
    volume = "30",
    number = "4",
    pages = "75--82",
    year = "1997",
}

@inproceedings{FuMNNRW03,
  author    = {C. Fu and R. Martin and K. Nagaraja and T. Nguyen and
	       B. Ryder and D. Wonnacott},
  title     = {Compiler-Directed Program-Fault Coverage for Highly Available
               {Java} Internet Services},
  booktitle = {Proc.\ 2003 Int.\ Conf.\ on Dependable Systems and Networks
               (DSN~2003)},
  year      = {2003},
  pages     = {595--604},
  address   = {San Francisco, USA},
}

@inproceedings{colby98automatically,
    author = "C. Colby and P. Godefroid and L. Jagadeesan",
    title = "Automatically Closing Open Reactive Programs",
    booktitle = "Proc.\ {SIGPLAN} Conf.\ on Programming Language Design and Implementation (PLDI~1998)",
    pages = "345--357",
    year = "1998",
    address = {Montreal, Canada},
}

@inproceedings{candea03,
  author = {G. Candea and M. Delgado and M. Chen and A. Fox},
  title = {Automatic Failure-Path Inference: A Generic Introspection Technique for {Internet} Applications},
  booktitle = {Proc.\ 3rd IEEE Workshop on Internet Applications (WIAPP~2003)},
  year = {2003},
  pages = {132},
  publisher = {IEEE Computer Society},
  address = {Washington, USA},
}

@inproceedings{Sinha99,
  author = {S. Sinha and M. Harrold},
  title = {Criteria for Testing Exception-Handling Constructs in {Java} Programs},
  booktitle = {Proc.\ IEEE Int.\ Conf.\ on Software Maintenance (ICSM~1999)},
  year = {1999},
  pages = {265},
  publisher = {IEEE Computer Society},
  address = {Washington, USA},
}

@inproceedings{FuRMW04,
  author    = {C. Fu and B. Ryder and A. Milanova and D. Wonnacott},
  title     = {Testing of {Java} web services for robustness},
  booktitle = {Proc.\ ACM/SIGSOFT Int.\ Symposium on Software
               Testing and Analysis (ISSTA~2004)},
  address = {Boston, USA},
  year      = {2004},
  pages     = {23--34},
}

@inproceedings{weimer04,
 author = {W. Weimer and G. Necula},
 title = {Finding and preventing run-time error handling mistakes},
 booktitle = {Proc.\ 19th ACM SIGPLAN Conf.\ on Object-Oriented Programming Systems, Languages \& Applications (OOPSLA~2004)},
 year = {2004},
 pages = {419--431},
 address = {Vancouver, Canada},
 publisher = {ACM Press},
}

@inproceedings{balakrishnan05,
  author = {G. Balakrishnan and T. Reps and D. Melski and T. Teitelbaum},
  title = {{WYSINWYX: What You See Is Not What You eXecute}},
  booktitle = {Proc.\ IFIP Working Conference on Verified Software: Theories, Tools, Experiments},
  year = {2005},
  address = {Zurich, Switzerland},
}

@misc{beck02,
 author = {K. Beck},
 title = {Test Driven Development: By Example},
 year = {2002},
 publisher = {Addison-Wesley Longman Publishing Co., Inc.},
 address = {Boston, USA},
}

@misc{gcc,
  key = "GCC",
  title = "The {Gnu} {Compiler} {Collection}",
  note = "\verb+http://gcc.gnu.org/+",
  year = 2005,
}

@misc{dbunit,
  key = "DbUnit",
  title = {{DBUnit}},
  note = "\verb+http://www.dbunit.org/+",
  year = 2007,
}

@misc{junit-faq,
  key = "JUnit FAQ",
  title = {{JUnit FAQ}},
  note = "\verb+http://junit.sourceforge.net/doc/faq/+",
  year = 2005,
}

@inproceedings{korel96,
 author = {B. Korel},
 title = {Automated test data generation for programs with procedures},
 booktitle = {ISSTA\ '96},
 year = {1996},
 pages = {209--215},
 publisher = {ACM Press},
 address = {New York, USA},
}

@preamble{ {\providecommand{\noopsort}[1]{}} }

@book{c-sharp,
 author = "{\noopsort{Microsoft}}{Microsoft Corporation}",
 title = {Microsoft Visual C\# .NET Language Reference},
 year = {2002},
 publisher = {Microsoft Press},
 address = {Redmond, USA},
}

@book{stroustrup2001,
 author = {B. Stroustrup},
 title = {{The C++ Programming Language, Third Edition}},
 year = {1997},
 publisher = {Addison-Wesley Longman Publishing Co., Inc.},
 address = {Boston, USA},
}

@book{meyer92,
 author = {B. Meyer},
 title = {Eiffel: the language},
 year = {1992},
 publisher = {Prentice-Hall, Inc.},
 address = {Upper Saddle River, USA},
}

@book{fentonpfleegermetrics,
 author = {N. Fenton and S. Pfleeger},
 title = {Software metrics (2nd {E}d.): a rigorous and practical approach},
 year = {1997},
 publisher = {PWS Publishing Co.},
 address = {Boston, USA}
}

@misc{freshmeat,
  key = "freshmeat",
  title = "Freshmeat",
  note = "\verb+http://freshmeat.net/+",
  year = 2005
}

@inproceedings{GrieskampETAL02FSMfromASM,
  author =       {W. Grieskamp and Y. Gurevich and
                  W. Schulte and M. Veanes},
  title =        {{Generating Finite State Machines
                  from Abstract State Machines}},
  booktitle =    "Proc.\ ISSTA~'02",
  address =      {Rome, Italy},
  month =        Jul,
  year =         2002,
  pages =        {112--122}
}

@misc{TVEC,
  key = "tvec",
  title = {{T-VEC}},
  note = "\verb+http://www.t-vec.com+"
}

@misc{PSOFT,
  key = "parasoft",
  title = {{Parasoft}},
  note = "\verb+http://www.parasoft.com+"
}

@inproceedings{drusinsky00,
  author = "D. Drusinsky",
  title = "{The Temporal Rover and the ATG Rover}",
  booktitle = "Proc.\ SPIN~'00",
  series = "LNCS",
  volume = 1885,
  pages = "323--330",
  publisher = "Springer",
  address = {Stanford, California, USA},
  year = 2000
}

@article{Singhal89,
  author    = {M. Singhal},
  title     = {Deadlock Detection in Distributed Systems},
  journal   = {IEEE Computer},
  volume    = {22},
  number    = {11},
  year      = {1989},
  pages     = {37--48},
  publisher={IEEE Computer Society Press},
}

@article{Knapp87,
  author    = {E. Knapp},
  title     = {Deadlock Detection in Distributed Databases},
  journal   = {ACM Computing Surveys},
  volume    = {19},
  number    = {4},
  year      = {1987},
  pages     = {303--328},
  publisher = {ACM Press},
}

@inproceedings{EytaniU04,
  author    = {Y. Eytani and S. Ur},
  title     = {Compiling a Benchmark of Documented Multi-Threaded Bugs},
  booktitle = {Proc.\ 18th Int.\ Parallel \& Distributed Processing Symposium (IPDPS~2004)},
  year      = {2004},
  pages     = {266a},
  publisher = {IEEE Computer Society Press},
  address   = {Santa Fe, USA},
}

@inproceedings{bruneton02,
  author = "E. Bruneton and R. Lenglet and T. Coupaye",
  title = {{ASM}: a code manipulation tool to implement adaptable systems.},
  booktitle = {Adaptable and Extensible Component Systems},
  address = {Grenoble, France},
  year = {2002},
}

@techreport{zweimueller03,
  author = {B. Zweim{\"u}ller},
  title = {{I/O} {E}rweiterung f{\"u}r die {JNuke} {V}irtual-{M}achine ({I/O} extension for the {JNuke} {Virtual} {Machine})},
  institution="ETH Z{\"u}rich",
  address = "Z{\"u}rich, Switzerland",
  year = 2003,
}

@misc{serp,
  author = "A. White",
  title = {{SERP}, an {Open Source} framework for manipulating {Java} bytecode
},
  note = {\texttt{http://serp.sourceforge.net/}},
  year = 2002,
}

@misc{specjvm98,
  author = {Standard Performance Evaluation Corporation},
  title = {{SPEC} benchmarks},
  note = {\texttt{http://www.spec.org/}},
  year = 1998,
}

@article{bik03,
  author = {D. Bik and M. Girkar},
  title = {Inside the {Int.\} Compiler},
  journal = {Linux Journal},
  volume = {106},
  year = {2003},
  publisher = {Specialized Systems Consultants, Inc.},
  pages = {91--94},
}

@book{chandra00,
 author = {R. Chandra and L. Dagum and D. Kohr and D. Maydan and J. McDonald and R. Menon},
 title = {Parallel programming in {OpenMP}},
 year = {2001},
 publisher = {Morgan Kaufmann Publishers, Inc.},
}

@article{dagum98,
 author = {L. Dagum and R. Menon},
 title = {{OpenMP}: An Industry-Standard {API} for Shared-Memory Programming},
 journal = {IEEE Computation in Science and Engineering Magazine},
 volume = {5},
 number = {1},
 year = {1998},
 pages = {46--55},
 publisher = {IEEE Computer Society Press},
}

@inproceedings{corbett00spin,
 author = {J. Corbett and M. Dwyer and J. Hatcliff and  Robby},
 title = {A Language Framework for Expressing Checkable Properties of Dynamic Software},
 booktitle = "Proc.\ 7th Int.\ SPIN Workshop (SPIN~2000)",
 series = {LNCS},
 volume = 1885,
 year = {2000},
 pages = {205--223},
 publisher = {Springer},
 address = "Stanford, USA",
}

@article{dijkstra72,
  author = "E. Dijkstra",
  title = "Notes on structured programming.",
  journal = "Structured Programming",
  publisher = "Academic Press",
  address = "London, UK",
  year = 1972,
}

@article{heath91,
  author = "M. Heath and J. Etheridge",
  title = "Visualizing the performance of parallel programs",
  journal = "IEEE Software",
  publisher = "IEEE Computer Society Press",
  year = 1991,
  volume = "8",
  number = "5",
  pages = "29--39",
}

@inproceedings{leBlanc85,
  author = "R. LeBlanc and A. Robbins",
  title = "Event-driven monitoring of distributed programs",
  booktitle = "Proc.\ 5th Int.\ Conf.\ on Distributed Computing Systems (ICDCS~1985)",
  publisher = "IEEE Computer Society Press",
  year = 1985,
  pages = "515--522",
  address = "Denver, USA",
}

@book{schumann00automated,
    author = "J. Schumann",
    title = "Automated Theorem Proving in Software Engineering",
    publisher = "Springer",
    year = "2000",
}

@inproceedings{iosi00,
  author = {R. Iosif and R. Sisto},
  title = {Using Garbage Collection in Model Checking},
  booktitle = "Proc.\ 7th Int.\ SPIN Workshop (SPIN~2000)",
  series = {LNCS},
  volume = 1885, 
  address = {Stanford, USA},
  year = 2000, 
  pages = {20--33},
  publisher = {Springer},
}

@inproceedings{Bohn:2004:SDRIs,
    author = "J. Bohn and F. Mattern",
    title = "Super-Distributed {RFID} Tag Infra{\-}structures",
    year = "2004",
    booktitle = "Proc.\ 2nd European Symposium on Ambient Int.\ligence (EUSAI 2004)",
    address = "Eindhoven, The Netherlands",
    series = {LNCS},
    volume = "3295",
    pages = "1--12",
    publisher = "Springer",
}

@inproceedings{artho-vmcai04,
  author = "C. Artho and K. Havelund",
  title = "Applying {J}lint to Space Exploration Software",
  booktitle = "Proc.\ 5th Int.\ Conf.\ on Verification, Model Checking and Abstract Interpretation (VMCAI~2004)",
  year = "2004",
  publisher = {Springer},
  series    = {LNCS},
  volume    = {2937},
  pages     = {297--308},
  address = "Venice, Italy",
}

@inproceedings{engler04,
  author = "D. Engler and M. Musuvathi",
  title = "Static analysis versus software model checking for bug finding",
  booktitle = "Proc.\ 5th Int.\ Conf.\ on Verification, Model Checking and Abstract Interpretation (VMCAI~2004)",
  year = "2004",
  publisher = {Springer},
  series    = {LNCS},
  volume    = {2937},
  pages     = {191--210},
  address = "Venice, Italy",
}

@inproceedings{chou-peled96,
  author = "C.-T. Chou and D. Peled",
  title = "Verifying a Model-checking Algorithm.",
  booktitle= "Proc.\ 2nd Int.\ Conf.\ on Tools and Algorithms for the Construction and Analysis of Systems (TACAS~1996)",
  volume = 1055,
  series = {LNCS},
  pages = "241--257",
  publisher = "Springer",
  address = "Passau, Germany",
  year = 1996,
}

@book{peled2001,
  author = "D. Peled",
  title = "Software Reliability Methods",
  publisher = "Springer",
  year = 2001,
}

@techreport{paulson03,
  author = "C. Paulson",
  title = "Mechanizing Compositional Reasoning for Concurrent Systems: Some Lessons",
  institution = "Computer Laboratory, University of Cambridge",
  number = "UCAM-CL-TR-573",
  address = "Cambridge, UK",
  year = "2003",
}

@inproceedings{ChTrWi99,
  author = "M. Chaudron and J. Tretmans and K. Wijbrans",
  title = "{Lessons from the Application of Formal Methods to the Design
            of a Storm Surge Barrier Control System}",
  booktitle = "{Proc.\ World Congress on Formal Methods in the Development of Computing Systems II (FM~1999)}",
  series = {LNCS},
  volume = "1709",
  year = "1999",
  pages = "1511--1526",
  publisher = "Springer",
  address = "Toulouse, France",
}

@book{clarke-etal99,
 author = {E. Clarke and O. Grumberg and D. Peled},
 title = {Model checking},
 year = {1999},
 publisher = {MIT Press},
}

@book{abrial96,
  author	= {J.-R. Abrial},
  title		= {The {B}-Book: Assigning Programs to Meanings},
  publisher	= {Cambridge University Press},
  year		= 1996,
}

@inproceedings{mcmillan03,
  author= "K. McMillan",
  title = "Interpolation and {SAT}-based model checking",
  booktitle = "Proc.\ 15th Int.\ Conf.\ on Computer Aided Verification (CAV~2003)",
  volume = "2725",
  series =  {LNCS},
  pages = "1--13",
  address =  "Boulder, USA",
  year = "2003",
  publisher = "Springer",
}

@book{mcmillan93,
 author = {K. McMillan},
 title = {Symbolic Model Checking},
 year = {1993},
 publisher = "Springer",
}

@inproceedings{biere99,
 author = {A. Biere and A. Cimatti and E. Clarke and M. Fujita and Y. Zhu},
 title = {Symbolic model checking using {SAT} procedures instead of {BDDs}},
 booktitle = {Proc.\ 36th ACM/IEEE conference on Design Automation (DAC~1999)},
 year = {1999},
 pages = {317--320},
 address = {New Orleans, USA},
 publisher = {ACM Press},
}

@inproceedings{burch90symbolic,
    author = "J. Burch and E. Clarke and K. McMillan and D. Dill and L. Hwang",
    title = "{S}ymbolic {M}odel {C}hecking: $10^{20}$ {S}tates and {B}eyond",
    booktitle = "Proc.\ 5th Annual {IEEE} Symposium on Logic in Computer Science (LICS~1990)",
    publisher = "IEEE Computer Society Press",
    address = "Washington, D.C., USA",
    pages = "1--33",
    year = "1990",
}

@article{bryant-ieeetc86,
  author = "R. Bryant",
  title = "Graph-Based Algorithms for {B}oolean Function Manipulation",
  journal = "IEEE Transactions on Computers",
  volume = "C-35",
  number = 8,
  year = 1986,
  pages = "677--691",
  publisher = {IEEE Computer Society Press},
}

@inbook{biere2003,
  author = {A. Biere and A. Cimatti and E. Clarke and O. Strichman and Y. Zhu},
  title = {Bounded Model Checking},
  series = {Advances in Computers},
  volume = 58,
  publisher = {Elsevier},
  year = 2003,
  note = {To appear},
}

@book{kerningham-richie,
  author = "B. Kernighan and D. Ritchie",
  title = {The {C} Programming Language},
  year = 1988,
  publisher = {Prentice-Hall},
}

@mastersthesis{vall00,
  author = "R. Vall\'ee-Rai",
  title = "Soot: A {Java} Bytecode Optimization Framework",
  school = "McGill University, Montreal",
  year = 2000,
}

@article{klein-nipkow03,
 author = {G. Klein and T. Nipkow},
 title = {Verified bytecode verifiers},
 journal = {Theoretical Computer Science},
 volume = {298},
 number = {3},
 year = {2003},
 pages = {583--626},
 publisher = {Elsevier Science},
}

@mastersthesis{wildmoser02,
  author = "M. Wildmoser",
  title = {Subroutines and {Java} Bytecode Verification},
  school = "Technical University of Munich",
  year = "2002",
}

@inproceedings{vall99soot,
  author = "R. Vall\'ee-Rai and L. Hendren and V. Sundaresan and P. Lam and E. Gagnon and P. Co",
  title = "Soot -- a {J}ava Optimization Framework",
  booktitle = "Proc.\ CASCON 1999",
  pages = "125--135",
  address = "Toronto, Canada",
  year = "1999",
}

@inproceedings{miecznikowski02,
  author = "J. Miecznikowski and L. Hendren",
  title = "Decompiling {Java} Bytecode: Problems, Traps and Pitfalls",
  booktitle = {Proc.\ 11th Int.\ Conf.\ on Compiler Construction (CC~2002)},
  volume    = {2304},
  year = {2002},
  pages = {111--127},
  publisher = {Springer},
  address = "Grenoble, France",
}

@book{meyer-downing-97-jasmin,
 author = {J. Meyer and T. Downing},
 title = {Java Virtual Machine},
 year = {1997},
 publisher = {O'Reilly \& Associates, Inc.},
}

@techreport{marlet01syntax,
  author = "R. Marlet",
  title = "Syntax of the {JCVM} Language To Be Studied in the {SecSafe} Project",
  institution = "Trusted Logic SA",
  number = "SECSAFE-TL-005-1.7",
  address = "Versailles, France",
  year = "2001",
}

@article{Pasareanu03,
   author = "C. Pasareanu and M. Dwyer and W. Visser",
   title = {Finding Feasible Abstract Counter-Examples},
   journal = "Int.\ Journal on Software Tools for Technology Transfer (STTT)",
   year = 2003,
   volume = 5,
   number = 1,
   publisher = "Springer",
   pages = {34--48},
}

@inproceedings{bourdoncle93,
   author = {F. Bourdoncle},
   title = {Efficient chaotic iteration strategies with widenings},
   publisher = {Springer},
   booktitle = {Proc.\ Formal Methods in Programming and their Applications},
   volume  = {735},
   series = {LNCS},
   pages = {128--141},
   address = "Novosibirsk, Russia",
   year = "1993",
}

@inproceedings{Artho05-inlining,
   author={C. Artho and A. Biere},
   title = {Subroutine Inlining and Bytecode Abstraction to Simplify Static and Dynamic Analysis},
   year={2005},
   booktitle = {Proc.\ 1st Workshop on Bytecode Semantics, Verification, Analysis and Transformation (BYTECODE~2005)},
   publisher = "Elsevier Science",
   series = "ENTCS",
   pages = {98--115},
   address = "Edinburgh, Scotland",
}

@mastersthesis{artho-mthesis,
  author = {C. Artho},
  title = {Finding Faults in Multi-threaded Programs},
  year = {2001},
  school = {ETH Z{\"u}rich},
}

@inproceedings{printezis00,
 author = {T. Printezis and D. Detlefs},
 title = {A generational mostly-concurrent garbage collector},
 booktitle = {Proc.\ 2nd international symposium on Memory management (ISMM~2000)},
 year = {2000},
 pages = {143--154},
 publisher = {ACM Press},
 address = "Minneapolis, USA",
}

@article{Godel31,
  author = {K. G{\"o}del},
  title = {{\"Uber formal unentscheidbare S\"atze der Principia Mathematica und verwandter Systeme I}},
  journal = {Monatshefte f\"ur Mathematik und Physik},
  volume = {38},
  pages = {173--198},
  note = {English translation: On formally undecidable propositions of {Principia Mathematica} and Related Systems I, {Oliver \& Boyd, London, UK}, 1962},
  year = {1931},
}

@incollection{BlanchetCousotEtAl02,
  author = {B. Blanchet and P. Cousot and R. Cousot and J. Feret and L. Mauborgne and A. Min{\'e} and D. Monniaux and X. Rival},
  title = {Design and {I}mplementation of a {S}pecial-{P}urpose {S}tatic {P}rogram {A}nalyzer for {S}afety-{C}ritical {R}eal-{T}ime {E}mbedded {S}oftware},
  booktitle = {The Essence of Computation: Complexity, Analysis, Transformation. Essays Dedicated to Neil D. Jones},
  pages = {85--108},
  publisher = {Springer},
  editor = {T. Mogensen and D. A. Schmidt and I. H. Sudborough},
  year = {2002},
  volume = {2566},
  series = {LNCS},
}

@misc{ieee-std729,
  author = {IEEE},
  title = {{IEEE Standard 729}: Glossary of Software Engineering Terminology},
  publisher = {IEEE Computer Society Press},
  year = {1983},
}

@article{Hoare1983,
 author = {C. Hoare},
 title = {Communicating sequential processes},
 journal = {Communications of the ACM},
 volume = {26},
 number = {1},
 year = {1983},
 pages = {100--106},
 publisher = {ACM Press},
}

@incollection{Dijkstra-1968,
   author = "E. Dijkstra",
   title = "Cooperating sequential processes",
   year = "1968",
   booktitle = "Programming Languages: NATO Advanced Study Institute",
   editor = "F. Genuys ",
   publisher = "Academic Press",
   pages = {43--112},
}

@book{henning-corba,
 author = {M. Henning and S. Vinoski},
 title = {Advanced CORBA programming with C++},
 year = {1999},
 publisher = {Addison-Wesley Longman Publishing Co., Inc.},
}

@book{Barnes97,
  editor    = {J. Barnes},
  title     = {Ada 95 Rationale, The Language, The Standard Libraries},
  publisher = {Springer},
  series    = {LNCS},
  volume    = {1247},
  year      = {1997},
}

@book{tanenbaum-os,
 author = {A. Tanenbaum},
 title = {Modern operating systems},
 year = {1992},
 publisher = {Prentice-Hall},
}

@inproceedings{ChendR04,
  author    = {F. Chen and M. d'Amorim and G. Ro\c{s}u},
  title     = {A Formal Monitoring-Based Framework for Software Development
               and Analysis},
  booktitle = {Proc.\ 6th Int.\ Conf.\ on Formal Engineering Methods (ICFEM~2004)},
  year      = {2004},
  address   = "Seattle, USA",
  pages     = {357--372},
  series = {LNCS},
  volume = {3308},
  publisher = "Springer",
}

@proceedings{rv01-05,
  title = "{1st, 2nd, 3rd, 4th, and 5th Int.\ Workshops on Run-time Verification (RV~2001 - RV~2005)}",
  publisher = "Elsevier Science",
  volume = "55(2), 70(4), 89(2), 113, TBD",
  series = "ENTCS",
  year = {2001 -- 2005},
  key = "RV",
}

@techreport{baur02,
  author = {M. Baur},
  title = {Pretty Printing for {JNuke}},
  institution="ETH Z{\"u}rich",
  address = "Z{\"u}rich, Switzerland",
  year = 2002,
}

@inproceedings{lee-etal2000,
 author = {S. Lee and B. Yang and S. Kim and S. Park and S. Moon and K. Ebciolu and E. Altman},
 title = {Efficient {Java} exception handling in just-in-time compilation},
 booktitle = {Proc.\ ACM Java Grande Conference},
 year = {2000},
 pages = {1--8},
 address = {San Francisco, USA},
 publisher = {ACM Press},
}

@misc{staerk02,
  author = {R. Staerk},
  title = "{Personal e-mail communication}",
  year   = {2001 -- 2002},
}

@inproceedings{bothner:freenix98,
    author = "P. Bothner",
    title = "Kawa --- compiling dynamic languages to the {Java VM}",
    booktitle = "Proc.\ USENIX 1998 Technical Conf., FREENIX Track",
    year = 1998,
    address = "New Orleans, {USA}",
    publisher = "{USENIX} {Association}",
}

@inproceedings{jgnat,
  author = {E. Briot.},
  title = {{JGNAT: The GNAT Ada 95 environment for the JVM.}},
  booktitle = {Ada France},
  year = {1999},
  address = {Brest, France},
}

@inproceedings{mohnen02,
 author = {M. Mohnen},
 title = {A Graph-Free Approach to Data-Flow Analysis},
 booktitle = {Proc.\ 11th Int.\ Conf.\ on Compiler Construction (CC~2002)},
 volume    = {2304},
 year = {2002},
 pages = {46--61},
 publisher = {Springer},
 address = "Grenoble, France",
}

@article{exp-eval-vv-tools04,
  title = {Experimental Evaluation of Verification and Validation Tools on {M}artian Rover Software},
  author = {G. Brat and D. Drusinsky and D. Giannakopoulou and A. Goldberg and K. Have{\-}lund and M. Lowry and C. Pasareanu and W. Visser and R. Washington},
  journal = {Formal Methods in System Design},
  volume = 25,
  number = 2,
  pages = "167--198",
  year = 2004,
  publisher = {Springer},
}

@inproceedings{marlowe90,
 author = {T. Marlowe and B. Ryder},
 title = {An efficient hybrid algorithm for incremental data flow analysis},
 booktitle = "Proc.\ 17th ACM Symposium on Principles of Programming Languages (POPL~1990)",
 year = {1990},
 pages = {184--196},
 address = {San Francisco, USA},
 publisher = {ACM Press},
}

@article{horwitz87,
 author = {S. Horwitz and A. Demers and T. Teitebaum},
 title = {An efficient general iterative algorithm for dataflow analysis},
 journal = {Acta Informatica},
 volume = {24},
 number = {6},
 year = {1987},
 pages = {679--694},
 publisher = {Springer},
}

@misc{sunwebserver,
  author = {{Sun Microsystems}},
  key = {{Sun Microsystems}},
  organization = {{Sun Microsystems}},
  title = {A Simple Multithreaded Web Server},
  note = {{\includegraphics[height=10pt,width=0.98\linewidth]{pics/webserver}}},
  year = 1997,
  address = "Santa Clara, USA",
}

@manual{jdk7,
  key = {{Oracle}},
  organization = {{Oracle}},
  title = "{J}ava {P}latform {S}tandard {E}dition 7 {API} {S}pecification",
  note = {\url{http://docs.oracle.com/javase/7/docs/api/}},
  year = 2013,
}

@manual{J2ME,
  key = {{Sun Microsystems}},
  author = {Sun Microsystems},
  title = {Connected, limited device configuration. Specification version 1.0a, May 2000.},
  note = {\texttt{http://java.sun.com/j2me/docs/}},
  address = "Santa Clara, USA",
}

@inproceedings{Freund1998,
  author={S. Freund},
  title="The Costs and Benefits of {Java} Bytecode Subroutines",
  booktitle={Formal Underpinnings of {Java} Workshop at {OOPSLA}},
  year={1998},
  address= {Vancouver, Canada},
}

@book{myers79,
 author = {G. Myers},
 title = {Art of Software Testing},
 year = {1979},
 publisher = {John Wiley \& Sons, Inc.},
}

@article{Libes:COMPSYS-4-2-99,
  author =       "D. Libes",
  title =        "{expect}: Scripts for Controlling Interactive
                 Processes",
  journal =      "Computing Systems",
  volume =       "4",
  number =       "2",
  pages =        "99--125",
  year =         "1991",
  publisher = "University of California Press",
}

@book{beck00,
 author = {K. Beck},
 title = {Extreme programming explained: embrace change},
 year = {2000},
 publisher = {Addison-Wesley Longman Publishing Co., Inc.},
}

@inproceedings{turner93,
 author = {C. Turner and D. Robson},
 title = {The State-Based Testing of Object-Oriented Programs},
 booktitle = {Proc.\ Conf.\ on Software Maintenance},
 year = {1993},
 pages = {302--310},
 publisher = {IEEE Computer Society Press},
 address = {Montr\'{e}al, Canada},
}

@inproceedings{weck-do,
  author = "W. Weck and C. Szyperski",
  title = "Do We Need Inheritance?",
  booktitle = "Workshop on Composability Issues in Object-Orientation (at ECOOP~1996)",
  address = "Linz, Austria",
  year = "1996",
}

@inproceedings{deursen01refactoring,
  author = "A. van Deursen and L. Moonen and A. van den Bergh and G. Kok",
  title = "Refactoring test code",
  booktitle = "Proc.\ 2nd Int.\ Conf. on eXtreme Programming and Flexible Processes in Software Engineering (XP~2001)",
  year = "2001",
  address = "Cagliari, Italy",
  publisher = {University of Cagliari},
}

@inproceedings{tevanian87unix,
    author = "A. Tevanian and R. Rashid and M. Young and D. Golub and M. Thompson and W. Bolosky and R. Sanzi",
    title = "A {UNIX} Interface for Shared Memory and Memory Mapped Files Under Mach",
    booktitle = "Proc.\ Summer USENIX Conf.\ (USENIX~1987)",
    pages = "53--68",
    year = "1987",
    address = "Phoenix, USA",
    publisher = "{USENIX} {Association}",
}

@misc{mpatrol,
  author = "G. Roy",
  title = {{mpatrol --- A library for controlling and tracing dynamic memory allocations}},
  note = {{\verb+http://www.cbmamiga.demon.co.uk/mpatrol/+}},
  year = "2002",
  address = "Edinburgh, Scotland",
}

@inproceedings{Pnueli1977,
  author =       "A. Pnueli",
  title =        "The temporal logic of programs",
  booktitle =    "Proc.\ 17th Annual Symposium on Foundations of Computer Science (FOCS~1977)",
  address =      "Rhode Island, USA",
  publisher =    "IEEE Computer Society Press",
  organization = "IEEE",
  year =         "1977",
  pages =        "46--57",
}

@inproceedings{racefinder,
  author = "Y. Ben-Asher and Y. Eytani and E. Farchi",
  title = "Heuristics for Finding Concurrent Bugs",
  booktitle = "Proc.\ Workshop on Parallel and Distributed Systems: Testing and Debugging (PADTAD~2003)",
  address = "Nice, France",
  pages = "288a",
  year = "2003",
}

@inproceedings{drusinsky03,
  author= "D. Drusinsky.",
  title = "Monitoring Temporal Rules Combined with Time Series.",
  booktitle = "Proc.\ 15th Int.\ Conf.\ on Computer Aided Verification (CAV~2003)",
  volume = "2725",
  series =  {LNCS},
  pages = "114--118",
  address =  "Boulder, USA",
  year = "2003",
  publisher = "Springer",
}

@inproceedings{havelund02synthesizing,
    author = "K. Havelund and G. Ro\c{s}u",
    title = "Synthesizing Monitors for Safety Properties",
    booktitle= "Proc.\ 8th Int.\ Conf.\ on Tools and Algorithms for the Construction and Analysis of Systems (TACAS~2002)",
    volume = "2280",
    pages = "342--356",
    series={LNCS},
    year = "2002",
    address = "Grenoble, France",
}

@inproceedings{eagle,
    author={H. Barringer and A. Goldberg and K. Havelund and K. Sen},
    title={Rule-Based Run-time Verification},
    booktitle = "Proc.\ 5th Int.\ Conf.\ on \mbox{Verification}, Model Checking and Abstract Interpretation (VMCAI\ 2004)",
    year={2004},
    publisher={Springer},
    address={Venice, Italy},
    series={LNCS},
    volume=2937,
    pages={44--57},
}

@book{asmbook03,
  author =	 {E. B{\"o}rger and R. F. St{\"a}rk},
  title =	 {Abstract State Machines --- A Method for High-Level
                  System Design and Analysis},
  publisher =	 {Springer},
  year =	 {2003},
}

@inproceedings{stoller02testing,
  author="S. Stoller",
  title="Testing Concurrent {Java} Programs using Randomized Scheduling",
  booktitle="Proc.\ 2nd Int.\ Workshop on Run-time Verification (RV~2002)",
  year=2002,
  series="ENTCS",
  publisher="Elsevier",
  volume="70(4)",
  address = "Copenhagen, Denmark",
  pages = {143--158},
}

@inproceedings{cheon02runtime,
  author = "Y. Cheon and G. Leavens",
  title = "A run-time assertion checker for the {J}ava {M}odeling {L}anguage",
  booktitle = {Proc.\ Int.\ Conf.\ on Software Engineering Research and Practice (SERP~2002)},
  pages = "322--328",
  publisher = "CSREA Press",
  address = "Las Vegas, USA",
  year = "2002",
}

@book{Meyer97,
  author = {B. Meyer},
  title = {Object-Oriented Software Construction},
  publisher = {Prentice-Hall},
  year = 1997,
  edition = {2nd},
}

@inproceedings{vandenberg01loop,
  author = "J. van den Berg and B. Jacobs",
  title = "The {LOOP} Compiler for {Java} and {JML}",
  booktitle= "Proc.\ 7th Int.\ Conf.\ on Tools and Algorithms for the Construction and Analysis of Systems (TACAS~2001)",
  series = {LNCS},
  volume = "2031",
  pages = "299--312",
  year = "2001",
  address = "Genova, Italy",
  publisher = "Springer",
}

@inproceedings{ConTest,
 author = {E. Farchi and Y. Nir and S. Ur},
 title = {Concurrent Bug Patterns and How to Test Them},
 booktitle = {Proc.\ 20th IEEE Int.\ Parallel \& Distributed Processing Symposium (IPDPS~2003)},
 year = {2003},
 pages = {286},
 publisher = {IEEE Computer Society Press},
 address = "Nice, France",
}

@book{junit,
 author = {J. Link and P. Fr{\"o}hlich},
 title = {Unit Testing in {J}ava: How Tests Drive the Code},
 year = {2003},
 publisher = {Morgan Kaufmann Publishers, Inc.},
}

@misc{bcel,
  author = "M. Dahm",
  title = {{BCEL}}, 
  note = "\verb+http://jakarta.apache.org/bcel/+",
  year = "2003",
}

@misc{jtrek,
  author = "S. Cohen",
  title = {{JTrek}},
  note = "Developed by Compaq, now discontinued.",
  url = "Compaq,\verb+http://www.compaq.com/java/download/jtrek/+",
  year = "2001",
}

@inproceedings{jones97backwardscompatible,
    author = "R. Jones and P. Kelly",
    title = {{Backwards-Compatible Bounds Checking for Arrays and Pointers in C Programs}},
    booktitle = "Proc.\ 3rd Int.\ Workshop on Automated and Algorithmic Debugging (AADEBUG~1997)",
    pages = "13--26",
    year = "1997",
    address = "Link{\"o}ping, Sweden",
    publisher = "Link{\"o}ping University Electronic Press",
}

@article{kiczales01overview,
    author = "G. Kiczales and E. Hilsdale and J. Hugunin and M. Kersten and J. Palm and W. Griswold",
    title = "An Overview of {AspectJ}",
    journal = {LNCS},
    volume = "2072",
    pages = "327--355",
    year = "2001",
    publisher = "Springer",
}

@article{daisy,
  author = {S. Freund and S. Qadeer},
  title = {Checking Concise Specifications For Multithreaded Software},
  journal = {Journal of Object Technology (JOT)},
  volume = {3},
  number = {6},
  year = {2004},
  pages = {81--101},
  publisher="ETH Z{\"u}rich",
}

@article{santaclaus,
  author = {J. Trono},
  title = {A new exercise in concurrency},
  journal = {SIGCSE Bulletin},
  volume = {26},
  number = {3},
  year = {1994},
  pages = {8--10},
  publisher = {ACM Press},
}

@Book{RumbaughETAL98UML,
   author =      "J. Rumbaugh and I. Jacobson and G. Booch",
   title =       "The Unified Modeling Language Reference Manual",
   publisher =   "Addison-Wesley Object Technology Series",
   year =        1998
}

@Book{GammaETAL95DesignPatterns,
  author =       {E. Gamma and R. Helm and R. Johnson and J. Vlissides},
  title =        {Design Patterns: Elements of Reusable Object-Oriented Software},
  year =         1995,
  publisher =    {{Addison-Wesley} Publishing Company},
  series =       {{Addison-Wesley} Professional Computing Series},
  address =      {New York, USA}
}

@article{artho03experiments,
  author = "C. Artho and H. Barringer and A. Goldberg and K. Havelund
  and S. Khurshid and M. Lowry and C. Pasareanu and G. Ro\c{s}u and K. Sen
  and W. Visser and R. Washington",
  title = {{Combining Test Case Generation with Run-time Verification}},
  journal = {ASM issue of Theoretical Computer Science},
  publisher = {Elsevier},
  volume = {336},
  number = {2/3},
  year = 2003,
}

@inproceedings{Artho05-genericanalysis,
  author={C. Artho and A. Biere},
  title = {Combined Static and Dynamic Analysis},
  booktitle = {Proc.\ 1st Int.\ Workshop on Abstract Interpretation of Object-Oriented Languages (AIOOL~2005)},
  publisher = "Elsevier Science",
  series = "ENTCS",
  address = "Paris, France",
  year = {2005},
}

@inproceedings{Artho04-blatomicity,
  author={C. Artho and A. Biere and K. Havelund},
  title = {Using block-local atomicity to detect stale-value concurrency errors},
  booktitle = {Proc.\ 2nd Int.\ Symposium on Automated Technology for Verification and Analysis (ATVA~2004)},
  year={2004},
  pages = {150--164},
  series = {LNCS},
  volume = {3299},
  publisher = {Springer},
  address = {Taipei, Taiwan},
}

@inproceedings{whaley04cloning,
  author = {J. Whaley and M. Lam},
  title = {Cloning-Based Context-Sensitive Pointer Alias Analysis Using Binary Decision Diagrams},
  booktitle = {Proc.\ ACM Int.\ Conf.\ on Programming Language Design and Implementation (PLDI~2004)},
  year = {2004},
  address = {Washington D.C., USA},
  publisher = {ACM Press},
  pages     = {131-144},
}

@article{blanchet03,
  author = {B. Blanchet},
  title = {Escape Analysis for {J}ava, Theory and Practice},
  journal = {ACM Transactions on Programming Languages and Systems (TOPLAS)},
  volume = {25},
  number = {6},
  pages = {713--775},
  year = {2003},
  publisher = {ACM Press},
}

@inproceedings{whaleyrinard99,
 author = {J. Whaley and M. Rinard},
 title = {{Compositional pointer and escape analysis for Java programs}},
 booktitle = {Proc.\ 14th ACM SIGPLAN Conf.\ on Object-Oriented Programming Systems, Languages \& Applications (OOPSLA~1999)},
 address = {Denver, USA},
 year = {1999},
 pages = {187--206},
 publisher = {ACM Press},
}

@inproceedings{choi99escape,
  author = "J. Choi and M. Gupta and M. Serrano and V. Sreedhar and S. Midkiff",
  title = {{Escape analysis for Java}},
  booktitle = {Proc.\ 14th ACM SIGPLAN Conf.\ on Object-Oriented Programming Systems, Languages \& Applications (OOPSLA~1999)},
  address = {Denver, USA},
  year = "1999",
  pages = {1--19},
  publisher = {ACM Press},
}

@inproceedings{bogdahoelzle99,
 author = {J. Bogda and U. H\"{o}lzle},
 title = {{Removing unnecessary synchronization in Java}},
 booktitle = {Proc.\ 14th ACM SIGPLAN Conf.\ on Object-Oriented Programming Systems, Languages \& Applications (OOPSLA~1999)},
 address = {Denver, USA},
 year = {1999},
 pages = {35--46},
 publisher = {ACM Press},
}

@inproceedings{blanchet99,
 author = {B. Blanchet},
 title = {{Escape analysis for object-oriented languages: application to Java}},
 booktitle = {Proc.\ 14th ACM SIGPLAN Conf.\ on Object-Oriented Programming Systems, Languages \& Applications (OOPSLA~1999)},
 address = {Denver, USA},
 year = {1999},
 pages = {20--34},
 publisher = {ACM Press},
}

@article{lipton1975,
 author = {R. Lipton},
 title = {Reduction: a method of proving properties of parallel programs},
 journal = {Communications of the ACM},
 volume = {18},
 number = {12},
 year = {1975},
 pages = {717--721},
 publisher = {ACM Press},
}

@inproceedings{Artho-etal2004,
  author={C. Artho and V. Schuppan and A. Biere and P. Eugster and M. Baur and B. Zweim\"{u}ller},
  title = {{JNuke: Efficient Dynamic Analysis for Java}},
  booktitle = "Proc.\ 16th Int.\ Conf.\ on Computer Aided Verification (CAV~2004)",
  year={2004},
  pages = {462--465},
  series = {LNCS},
  volume = {3114},
  publisher = {Springer},
  address = {Boston, USA},
}

@inproceedings{flanagan04,
  author = {C. Flanagan},
  title = {{Verifying Commit-Atomicity using Model-Checking}},
  booktitle = "Proc.\ 11th Int.\ SPIN Workshop (SPIN~2004)",
  series = {LNCS},
  volume = 2989,
  publisher = "Springer",
  year = {2004},
  pages = {252--266},
  address = {Barcelona, Spain},
}

@inproceedings{flanaganfreund04,
 author = {C. Flanagan and S. Freund},
 title = {{Atomizer: A Dynamic Atomicity Checker for Multithreaded Programs}},
 booktitle = "Proc.\ 31st ACM Symposium on Principles of Programming Languages (POPL~2004)",
 year = {2004},
 pages = {256--267},
 publisher = {ACM Press},
}

@inproceedings{kim02macs,
  author = {M. Kim and I. Lee and U. Sammapun and J. Shin and O. Sokolsky},
  title     = {Monitoring, Checking, and Steering of Real-Time Systems.},
  booktitle={Proc.\ 2nd Int.\ Workshop on Run-time Verification (RV~2002)},
  series = {ENTCS},
  volume = {70},
  number = {4},
  year = {2002},
  publisher = {Elsevier},
}

@inproceedings{kim01java-mac,
  author = {M. Kim and S. Kannan and I. Lee and O. Sokolsky and M. Viswanathan},
  title = {{Java-MaC}: a Run-time Assurance Tool for {J}ava Programs},
  booktitle = {Proc.\ 1st Int.\ Workshop on Run-time Verification (RV~2001)},
  series = {ENTCS},
  volume = {55},
  year = {2001},
  publisher = {Elsevier},
  address = {Paris, France},
  pages = {115--132},
}

@inproceedings{bull99methodology,
    author = "J. Bull and L. Smith and M. Westhead and D. Henty and R. Davey",
    title = "A Methodology for Benchmarking {J}ava {G}rande Applications",
    booktitle = "Proc.\ ACM Java Grande Conference",
    year = "1999",
    address = "San Francisco, USA",
    pages   = {81--88},
}

@inproceedings{purify,
  title       = {{Purify}: Fast Detection of Memory Leaks and Access Errors},
  author = "R. Hastings and B. Joyce",
  booktitle = "Proc.\ Winter USENIX Conf.\ (USENIX~1992)",
  year        = "1992",
  address = "San Francisco, USA",
  publisher = "{USENIX} {Association}",
}

@inproceedings{Haehnle00a,
  author =       {W. Ahrendt and T. Baar and B. Beckert
                  and M. Giese and E. Habermalz and R.
                  H\"ahnle and W. Menzel and P. Schmitt},
  title =        {The {KeY} Approach: {I}ntegrating Object Oriented
                  Design and Formal Verification},
  series =       {LNCS},
  volume =       1919,
  year =         "2000",
  booktitle =    "Proc.\ 7th European Workshop on Logic in Artificial Int.\igence (JELIA~2000)",
  address = {M\'{a}laga, Spain},
  pages = "21--36",
  publisher =    "Springer",
}

@book{Holzmann04,
   author = {G. Holzmann},
   title = {The {SPIN} Model Checker},
   publisher = {Addison-Wesley},
   year = {2004}
}

@book{Holzmann91,
   author = {G. Holzmann},
   title = {Design and Validation of Computer Protocols},
   publisher = {Prentice-Hall},
   year = {1991}
}

@inproceedings{CousotCousot77-1,
   author =    {P. Cousot and R. Cousot},
   title =     {Abstract interpretation: a unified lattice model for static 
                analysis of programs by construction or approximation of 
                fixpoints},
   booktitle = "Proc.\ 4th ACM Symposium on Principles of Programming Languages (POPL~1977)",
   publisher = {ACM Press},
   pages     = {238--252},
   year =      1977,
   address = "Los Angeles, USA",
}

@inproceedings{nethercote03valgrind,
    author = {N. Nethercote and J. Seward},
    title = {Valgrind: A Program Supervision Framework},
    booktitle="Proc.\ 3rd Int.\ Workshop on Run-time Verification (RV~2003)",
    series = {ENTCS},
    volume = {89},
    publisher = {Elsevier},
    year = {2003},
    address = "Boulder, USA",
    pages = {22--43},
}

@inproceedings{robby03,
 author = {Robby and M. Dwyer and J. Hatcliff},
 title = {Bogor: an extensible and highly-modular software model checking framework},
 booktitle = {Proc.\ 9th European Software Engineering Conf.~(ESEC~2003)},
 year = {2003},
 address = "Helsinki, Finland",
 publisher = "ACM Press",
}

@article{instantreplay,
  title     = "Debugging parallel programs with Instant Replay",
  author    = "T. LeBlanc and J. Mellor-Crummey",
  journal = "IEEE Transactions on Computers",
  volume = "C-36",
  number = "4",
  pages = "471--482",
  year      = "1987",
  publisher = "IEEE Computer Society Press"

}

@inproceedings{choi98deterministic,
  author = "J.-D. Choi and H. Srinivasan",
  title  = "Deterministic Replay of Java Multithreaded Applications",
  booktitle   = "Proc.\ SIGMETRICS Symp.~on Parallel and Distributed Tools",
  year   = "1998",
  address = "Welches, Oregon",
}

@inproceedings{praungross03,
  author={C. von Praun and T. Gross},
  title={Static Detection of Atomicity Violations in Object-Oriented Programs},
  booktitle="Proc.\ 5th ECOOP Workshop on Formal Techniques for Java-like Programs \mbox{(FTfJP\ 2003)}",
  series="Technical Reports from ETH Z{\"u}rich",
  publisher="ETH Z{\"u}rich",
  volume="408",
  year = {2003},
  address = "Darmstadt, Germany",
  pages = {99--108},
}

@inproceedings{wangstoller03,
  author="L. Wang and S. Stoller",
  title={Run-time Analysis for Atomicity},
  year=2003,
  booktitle="Proc.\ 3rd Int.\ Workshop on Run-time Verification (RV~2003)",
  series = {ENTCS},
  publisher="Elsevier",
  volume="89(2)",
  address="Boulder, USA",
  pages = {224--242},
}

@inproceedings{flanaganqadeer03,
  author="C. Flanagan and S. Qadeer",
  title={Types for Atomicity},
  year=2003,
  booktitle="Proc.\ ACM Int.\ Workshop on Types in Language Design and Implementation (TLDI~2003)", 
  pages = {1--12},
  address={New Orleans, USA},
  publisher = {ACM Press},
}

@article{Artho-etal2003,
  author={C. Artho and K. Havelund and A. Biere},
  title={High-Level Data Races},
  journal={Journal on Software Testing, Verification \& Reliability {(STVR)}},
  year={2003},
  volume = {13},
  number = {4},
  pages = {220--227},
  publisher={John Wiley \& Sons},
}

@inproceedings{mittal98consistency,
    author = "N. Mittal and V. Garg",
    title = {Consistency Conditions for Multi-Object Distributed Operations},
    booktitle = "Proc.\ Int.\ Conf.~on Distributed Computing Systems (ICDCS~1998)",
    pages = "582--599",
    year = "1998",
    address = "Amsterdam, The Netherlands",
  publisher = "IEEE Computer Society Press",
}

@manual{j2ee,
  key = {{Sun Microsystems}},
  organization = {{Sun Microsystems}},
  title = {{Java 2 Platform Enterprise Edition} Specification},
  note = "\verb+http://java.sun.com/j2ee/+",
  year = {2005},
  address = "Santa Clara, USA",
}

@techreport{burrows-leino02,
  author = {M. Burrows and R. Leino},
  title = {Finding stale-value errors in concurrent programs},
  institution="Compaq SRC",
  number = "SRC-TN-2002-004",
  address = "Palo Alto, USA",
  year = {2002},
}

@inproceedings{goldberg-havelund02,
  author = {A. Goldberg and K. Havelund},
  title = {Instrumentation of {J}ava Bytecode for Run-time Analysis},
  booktitle="Proc.\ 5th ECOOP Workshop on Formal Techniques for Java-like Programs (FTfJP\ 2003)",
  series="Technical Reports from ETH Z{\"u}rich",
  publisher="ETH Z{\"u}rich",
  volume="408",
  year = {2003},
  address = "Darmstadt, Germany",
  pages = {151--159},
}

@inproceedings{havelund00,
  author = "K. Havelund",
  title = {Using Run-time Analysis to Guide Model Checking of {Java} Programs},
  booktitle = "Proc.\ 7th Int.\ SPIN Workshop (SPIN~2000)",
  series = {LNCS},
  volume = 1885,
  publisher = "Springer",
  year = 2000,
  pages = "245--264",
  address = "Stanford, USA",
}

@inproceedings{havelund-rosu01-rv,
  author = {K. Havelund and G. Ro\c{s}u},
  title = {Monitoring {Java} Programs with {Java PathExplorer}},
  booktitle = {Proc.\ 1st Int.\ Workshop on Run-time Verification (RV~2001)},
  series = {ENTCS},
  volume = {55},
  year = {2001},
  pages = {97--114},
  address = {Paris, France},
  publisher = {Elsevier},
}

@inproceedings{corbett-et-al00,
  author = "J. Corbett and M. Dwyer and J. Hatcliff and
            C. Pasareanu and Robby and S. Laubach and H. Zheng",
  title  = {{Bandera}: Extracting Finite-state Models from {Java} Source Code},
  address = "Limerick, Ireland",
  booktitle= "Proc.\ 22nd Int.\ Conf.~on Software Engineering (ICSE~2000)",
  pages = "439-448",
  publisher = "ACM Press",
  year   = 2000,
}

@inproceedings{holzmann-smith99,
  author      = "G. Holzmann and M. Smith",
  title       = {A Practical Method for Verifying Event-Driven Software},
  booktitle= "Proc.\ 21st Int.\ Conf.~on Software Engineering (ICSE~1999)",
  publisher   = "ACM Press",
  address = "Los Angeles, USA",
  pages = "597--607",
  year        = 1999,
}

@inproceedings{godefroid97,
  author = "P. Godefroid",
  title = {Model Checking for Programming Languages using {VeriSoft}},
  booktitle = "Proc.\ 24th ACM Symposium on Principles of Programming Languages (POPL~1997)",
  pages = "174--186",
  address = "Paris, France",
  year = 1997,
  publisher = "ACM Press",
}

@article{visser-et-al03,
  author = "W. Visser and K. Havelund and G. Brat and S. Park and F. Lerda",
  title = {Model Checking Programs},
  journal = "Automated Software Engineering Journal",
  year = 2003,
  volume = 10,
  number = 2,
  pages = {203--232},
  publisher = "Springer",
}

@article{havelund-pressburger00,
  author = "K. Havelund and T. Pressburger",
  title = {Model Checking {Java} Programs using {Java PathFinder}},
  journal = "Int.\ Journal on Software Tools for Technology Transfer (STTT)",
  year = 2000,
  volume = 2,
  number = 4,
  pages = "366--381",
  publisher = "Springer",
}

@inproceedings{flanagan-et-al02,
  author = "C. Flanagan and R. Leino and M. Lillibridge and G. Nelson
            and J. Saxe and R. Stata",
  title = {{Extended static checking for Java}},
  booktitle = {Proc.\ ACM Int.\ Conf.\ on Programming Language Design and Implementation (PLDI~2002)},
  year = {2002},
  pages = {234--245},
  address = {Berlin, Germany},
  publisher = {ACM Press},
}

@inproceedings{harrow00,
  author = "J. Harrow",
  title = {Run-time Checking of Multithreaded Applications with {Visual Threads}},
  booktitle = "Proc.\ 7th Int.\ SPIN Workshop (SPIN~2000)",
  series = {LNCS},
  volume = 1885,
  year = 2000,
  pages     = {331-342},
  publisher = "Springer",
  address = "Stanford, USA",
}

@inproceedings{Artho2001,
  author={C. Artho and A. Biere},
  title={Applying Static Analysis to Large-Scale, Multithreaded {J}ava Programs.},
  booktitle={Proc.\ 13th Australian Software Engineering Conference (ASWEC 2001)},
  year={2001},
  publisher={IEEE Computer Society Press},
  pages = {68--75},
  address = {Canberra, Australia},
}

@book{GoslingJoySteeleBracha2000,
  author={J. Gosling and B. Joy and G. Steele and G. Bracha},
  title={The {Java Language} Specification, Third Edition},
  publisher={Addison{-}Wesley},
  year={2005},
}

@mastersthesis{Bruening99systematic,
  author = "D. Bruening",
  title = {Systematic Testing of Multithreaded {J}ava Programs},
  school = "MIT",
  year = "1999",
}

@mastersthesis{eugster03,
  author = "P. Eugster",
  title = {{Java Virtual Machine} with Rollback Procedure allowing Systematic and Exhaustive Testing of Multithreaded {Java} Programs},
  school = "ETH Z{\"u}rich",
  year = "2003",
}

@mastersthesis{farkas04,
  author = "P. Farkas",
  title = {{Garbage Collection for JNuke, a Java Virtual Machine for Run-time Verification and Model Checking}},
  school = "ETH Z{\"u}rich",
  year = "2004",
}

@inproceedings{PraunGross2001,
  author={C. von Praun and T. Gross},
  title={Object-Race Detection},
  booktitle = {Proc.\ 16th ACM SIGPLAN Conf.\ on Object-Oriented Programming Systems, Languages \& Applications (OOPSLA\ 2001)},
  address={Tampa Bay, USA},
  year={2001},
  pages = "70--82",
  publisher={ACM Press},
}

@article{savage97eraser,
    author = "S. Savage and M. Burrows and G. Nelson and P. Sobalvarro and T. Anderson",
    title = {Eraser: A Dynamic Data Race Detector for Multithreaded Programs},
    journal = "ACM Transactions on Computer Systems",
    volume = "15",
    number = "4",
    year = "1997",
    pages = "391--411",
}

@book{StaerkSchmidBoerger2001,
  author={R. St{\"a}rk and J. Schmid and E. B{\"o}rger},
  title={{Java and the Java Virtual Machine}},
  publisher={Springer},
  year={2001},
}

@book{LindholmYellin1999,
  author={T. Lindholm and A. Yellin},
  title={The {Java Virtual Machine} Specification, Second Edition},
  publisher={Addison{-}Wesley},
  year={1999},
}

@book{Lea1999,
  author={D. Lea},
  title={Concurrent Programming in {Java}, Second Edition},
  publisher={Addison{-}Wesley},
  year={1999},
}

@inproceedings{SchuppanBaurBiere04,
  author = {V. Schuppan and M. Baur and A. Biere},
  title = {{JVM}-Independent Replay in {Java}},
  year = {2004},
  booktitle = {Proc.\ 4th Int.\ Workshop on Run-time Verification (RV~2004)},
  series = {ENTCS},
  volume = {113},
  pages={85--104},
  publisher = {Elsevier},
  address = {M\'{a}laga, Spain},
}

@inproceedings{Artho-etalHLDR,
  author={C. Artho and K. Havelund and A. Biere},
  title={{High-Level Data Races}},
  booktitle={VVEIS~2003: The First Int.\ Workshop on Verification and Validation of Enterprise Information Systems},
  address = {Angers, France},
  year={2003},
  publisher = {ICEIS Press},
}

@article{herlihywing90,
 author = {M. Herlihy and J. Wing},
 title = {{Linearizability: A Correctness Condition for Concurrent Objects}},
 journal = {ACM Transactions on Programming Languages and Systems (TOPLAS)},
 volume = {12},
 number = {3},
 year = {1990},
 pages = {463--492},
 publisher = "ACM Press",
}

@article{lamport79,
  author = {L. Lamport},
  title = {{How to Make a Multiprocessor that Correctly Executes Multiprocess Programs}},
  journal = "IEEE Transactions on Computers",
  volume = "9",
  pages  = "690--691",
  year = "1979",
  publisher={IEEE Computer Society Press},
}

@article{afek93lazy,
  author = "Y. Afek and G. Brown and M. Merritt",
  title = {{Lazy Caching}},
  journal = {ACM Transactions on Programming Languages and Systems (TOPLAS)},
  volume = "15",
  number = "1",
  publisher = "ACM Press",
  pages = "182--205",
  year = "1993",
}

@inproceedings{chamberlin76,
 author = {D. Chamberlin and R. Boyce},
 title = {{SEQUEL: A structured English query language}},
 booktitle = {Proc.\ First ACM SIGFIDET (now SIGMOD) workshop on Data description, access and control},
 year = {1974},
 pages = {249--264},
 address = "Ann Arbor, USA",
 publisher = "ACM Press",
}

@article{papadimitriou79,
 author = {C. Papadimitriou},
 title = {{The Serializability of Concurrent Database Updates}},
 journal = {Journal of the ACM (JACM)},
 volume = {26},
 number = {4},
 year = {1979},
 pages = {631--653},
 publisher = "ACM Press",
}

@inproceedings{AbbadiSC85,
  author    = {A. Abbadi and D. Skeen and F. Cristian},
  title     = {{An Efficient, Fault-Tolerant Protocol for Replicated Data Management}},
  booktitle = {Proc.\ 4th ACM SIGACT-SIGMOD Symposium on Principles of Database Systems (PODS~1985)},
  address   = {Portland, USA},
  publisher = {ACM Press},
  year      = {1985},
  pages     = {215--229},
}

@unpublished{bensalem-havelund03,
  author = {S. Bensalem and K. Havelund},
  title = {{Deadlock Analysis of Multi-Threaded Java Programs}},
  note = {To be published},
  year = {2003},
}

@book{Bernstein87,
  author="P. Bernstein and V. Hadzilacos and N. Goodman",
  title={{Concurrency Control and Recovery in Database Systems}},
  year=1987,
  publisher="Addison-Wesley",
}

@misc{Jprobe,
  author = "Sitraka",
  title = {{JProbe}},
  note = "\verb+http://www.quest.com/jprobe/+",
  year = 2005,
  address = "Irvine, USA",
}

@misc{burrows00,
  author = {M. Burrows},
  title = {{Personal communication}},
  year   = 2000,
}

@misc{lea00,
  author = {D. Lea},
  title = {{Personal e-mail communication}},
  year   = 2000,
}

@inproceedings{ball-et-al01,
  author = "T. Ball and A. Podelski and S. Rajamani",
  title  = {{Boolean and Cartesian Abstractions for Model Checking C Programs}},
  booktitle= "Proc.\ 7th Int.\ Conf.\ on Tools and Algorithms for the Construction and Analysis of Systems (TACAS~2001)",
  series     = {LNCS},
  volume = 2031,
  address = "Genova, Italy",
  pages = "268--285",
  year   = 2001,
  publisher = "Springer",
}

@inproceedings{stoller00,
  author = "S. Stoller",
  title = {{Model-Checking Multi-threaded Distributed Java Programs}},
  booktitle = "Proc.\ 7th Int.\ SPIN Workshop (SPIN~2000)",
  series = {LNCS},
  volume = 1885,
  year = 2000,
  pages = "224--244",
  publisher = "Springer",
  address = {Stanford, USA},
}

@inproceedings{visser-et-al00,
  author = "W. Visser and K. Havelund and G. Brat and S. Park",
  title = {{Model Checking Programs}},
  booktitle = "Proc.\ ASE~2000: The 15th IEEE Int.\ Conf.\ on Automated Software Engineering",
  publisher={IEEE Computer Society Press},
  year        = 2000,
  address = "Grenoble, France",
}

@article{havelund-lowry-penix98,
  author = "K. Havelund and M. Lowry and J. Penix",
  title = {{Formal Analysis of a Space Craft Controller using SPIN}},
  journal = "IEEE Transactions on Software Engineering",
  volume = 27,
  number = 8,
  year = 2001,
  pages  = {749--765},
  note = "An earlier version occurred in the {\em {Proc.\ 4th Int.\ SPIN
        workshop}}, 1998, Paris, France",
  publisher={IEEE Computer Society Press},
}

@techreport{detlefs-et-al98,
  author = "D. Detlefs and R. Leino and G. Nelson and
            J. Saxe",
  institution = "Compaq Systems Research Center, Palo Alto, USA",
  number = {159},
  title = {{Extended Static Checking}},
  year = 1998,
}

@article{rosenberg95thoughts,
    author = "A. Rosenberg",
    title = {{Thoughts on Parallelism and Concurrency in Computing Curricula}},
    journal = "ACM Computing Surveys",
    volume = "27",
    number = "2",
    pages = "280--283",
    year = "1995",
}

@article{schuldt-etal-TODS,
  author =   {H.~Schuldt and G.~Alonso and C.~Beeri and H.-J.~Schek},
  title =    {{Atomicity and Isolation for Transactional Processes}},
  journal =      {ACM Transactions on Database Systems (TODS)},
  year =     {2002},
  volume =   {27},
  number =   {1},
  pages =    {63--116},
  publisher = {ACM Press},
}

@book{Reilly:Pthreads,
   author = {B. Nichols and D. Buttlar and J. Farrell},
   publisher = {O'Reilly},
   title = {{Pthreads Programming}},
   year = {1998},
}

@manual{J2SE,
  key = {{Sun Microsystems}},
  organization = {{Sun Microsystems}},
  title = {{Java 2 SDK, Standard Edition Documentation}},
  note = {\texttt{http://java.sun.com/j2se/1.4/docs/}},
  year = {2004},
  address = "Santa Clara, USA",
}

@book{Butenhof1997,
  author={D. Butenhof},
  title={{Programming with POSIX Threads}},
  publisher={Addison{-}Wesley},
  year={1997},
}

@book{NicholsButtlarFarrell1996,
  author={B. Nichols and D. Buttlar and J. Farrell},
  title={{Pthreads Programming}},
  publisher={O'Reilly},
  year={1996},
}

@inproceedings{Pell97,
  author = {B. Pell and E. Gat and R. Keesing and
            N. Muscettola and B. Smith},
  title = {{Plan Execution for Autonomous Spacecrafts}},
  booktitle = {Proc.\ Int.\ Joint Conf.\ on Artificial Intl.\ligence (IJCAI~1997)},
  address = {Nagoya, Japan},
  year = {1997},
  pages = {1234--1239},
}

@phdthesis{artho-thesis,
  author = {C. Artho},
  title = {Combining Static and Dynamic Analysis to Find Multi-threading Faults Beyond Data Races},
  year = {2005},
  school = {ETH Z{\"u}rich},
}
